% Constructor of trapezoidal quadrature rule, on the interval -1 <=x<= +1.
%
% function retobj = trapezoidal_rule (varargin)
%
%   Call as:
%      ir = trapezoidal_rule;
%
function retobj = trapezoidal_rule (varargin)
    class_name='trapezoidal_rule';
    parent=classbase;
    if (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        end
        if  ~(strcmp(class(varargin{1}),'double'))
            options =varargin{1};
            self.dim = options.dim;
        else
            self.dim = varargin{1};
        end
    else
        self.dim=1;
    end
    switch self.dim
        case 1
            self.param_coords = [-1; 1];
            self.weights = [1, 1];
        case 2
            self.param_coords = [-1,-1; 1,-1; 1, 1; -1, 1];
            self.weights = [1, 1, 1, 1];
        case 3
            self.param_coords = [-1,-1,-1; 1,-1,-1; 1, 1,-1;-1, 1,-1;-1,-1, 1; 1,-1, 1; 1, 1, 1;-1, 1, 1;];
            self.weights = [1, 1, 1, 1, 1, 1, 1, 1];
        otherwise
            error('Unsupported Dimension');
    end
    retobj = class(self,class_name,parent);
end
