[fens,gcells] = t3block2d(1, 1, 1, 1, []);
[fens,gcells] = T3_to_T6(fens,gcells, []);
geom=field(struct ('name', ['geom'], 'dim', 2,'fens',fens));
U=0*geom;
% gv=graphic_viewer;
% gv=reset (gv,[]);
% draw(gcells(1), gv, struct ('x',geom,'u',0*U, 'facecolor','red','shrink',0.9))
% draw(gcells(1), gv, struct ('x',geom,'u',0*U, 'facecolor','none'))

conn =get(gcells(1),'conn');
xyz=gather(geom,conn,'values','noreshape');
a=1;
xyz(1,:) = [0,0];
xyz(2,:) = [a,0];
xyz(3,:) = [a/2,sqrt(3)/2*a];
xyz(4,:) =mean(xyz([1,2],:));
xyz(5,:) =mean(xyz([2,3],:));
xyz(6,:) =mean(xyz([3,1],:));
corners = [0,0;1,0;0,1;1/2,0;1/2,1/2;0,1/2];

color = 0.8*[1,1,1];
for eta=linspace(0,1,Nl)
    xi =linspace(0,1-eta,n);
    for i=1:length(xi)
        N=bfun(gcells(1),[xi(i),eta]);
        xy(i,1:2) =N'*xyz;
    end
    plot(xy(:,1),xy(:,2),'k','color' , color,'linewidth',3);
    hold on
end
clear xy

for xi=linspace(0,1,Nl)
    eta =linspace(0,1-xi,n);
    for i=1:length(eta)
        N=bfun(gcells(1),[xi,eta(i)]);
        xy(i,1:2) =N'*xyz;
    end
    plot(xy(:,1),xy(:,2),'k--','color' , color,'linewidth',3);
    hold on
end
clear xy

for zeta=linspace(0,1,Nl)
    eta =linspace(0,zeta,n);
    for i=1:length(eta)
        xi=zeta-eta(i);
        N=bfun(gcells(1),[xi,eta(i)]);
        xy(i,1:2) =N'*xyz;
    end
    plot(xy(:,1),xy(:,2),'k:','color' , color,'linewidth',3);
    hold on
end
clear xy

for j= 1:size( corners,1)
    N=bfun(gcells(1),corners(j,:));
    xy(1,1:2) =N'*xyz;
    plot(xy(:,1),xy(:,2),'ko','color' , color,'linewidth',3);
end 


c=mean(xyz);
% Edges pushed inward
b= 0.35;
xyz(4,:) =(1-b)*c +b*xyz(4,:); 
xyz(5,:) =(1-b)*c +b*xyz(5,:); 
xyz(6,:) =(1-b)*c +b*xyz(6,:); 

% One edge pushed outward
% b=1.4;
% xyz(5,:) =(1-b)*c +b*xyz(5,:); 

% Mid-edge node moved towards corner
% b= 1.5;
% xyz(4,:) =(1-b)*c +b*xyz(4,:); 
% b= 0.2;
% xyz(4,:) =(1-b)*xyz(2,:) +b*xyz(4,:); 

n=100;
Nl =5;

for eta=linspace(0,1,Nl)
    xi =linspace(0,1-eta,n);
    for i=1:length(xi)
        N=bfun(gcells(1),[xi(i),eta]);
        xy(i,1:2) =N'*xyz;
    end
    plot(xy(:,1),xy(:,2),'k','linewidth',3);
    hold on
end
clear xy

for xi=linspace(0,1,Nl)
    eta =linspace(0,1-xi,n);
    for i=1:length(eta)
        N=bfun(gcells(1),[xi,eta(i)]);
        xy(i,1:2) =N'*xyz;
    end
    plot(xy(:,1),xy(:,2),'k--','linewidth',3);
    hold on
end
clear xy

for zeta=linspace(0,1,Nl)
    eta =linspace(0,zeta,n);
    for i=1:length(eta)
        xi=zeta-eta(i);
        N=bfun(gcells(1),[xi,eta(i)]);
        xy(i,1:2) =N'*xyz;
    end
    plot(xy(:,1),xy(:,2),'k:','linewidth',3);
    hold on
end
clear xy

for j= 1:size( corners,1)
    N=bfun(gcells(1),corners(j,:));
    xy(1,1:2) =N'*xyz;
    plot(xy(:,1),xy(:,2),'ko','linewidth',3);
end 

axis equal off


