function [utip]=shear_wall_had
    % Parameters:
    E=1e6;
    magn=1;
    graphics=true;
    Plot_errors=0;
    scale=10000;
    nu=1/3;
    convutip=23.97;
    a=1; b=5; c=1.5; d=4;
    bkgh=a;
    fs={...
        ['curve 1 line ' num2str(0) ' ' num2str(0) ' ' num2str(a) ' ' num2str(0)],...
        ['curve 2 line ' num2str(a) ' ' num2str(0) ' ' num2str(a) ' ' num2str(c)],...
        ['curve 3 line ' num2str(a) ' ' num2str(c) ' ' num2str(a+b) ' ' num2str(c)],...
        ['curve 4 line ' num2str(a+b) ' ' num2str(c) ' ' num2str(a+b) ' ' num2str(c+d)],...
        ['curve 5 line ' num2str(a+b) ' ' num2str(c+d) ' ' num2str(0) ' ' num2str(c+d)],...
        ['curve 6 line ' num2str(0) ' ' num2str(c+d) ' ' num2str(0) ' ' num2str(0)],...
        ['subregion 1  property 1 boundary  1  2 3 4 5 6']
        };
    utip=[];
    Targetnel= 5000;
    
    
    [fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher(cat(2,fs,{['m-ctl-point constant ' num2str(bkgh)]}), 1.0);
    
    for Adapt=1:3
        
        %     mesh{1}=fens;
        %     mesh{2}=gcells;
        %     drawmesh(mesh); view(2); pause (1)
        %     Material
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_ss_linel_biax (struct('property',prop, ...
            'reduction','stress'));
        % Finite element block
        feb = feblock_defor_ss(struct ('mater',mater, 'gcells',gcells, 'integration_rule',tri_rule(1)));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero outfunction five
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,a,0,0],'inflate',a/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[a+b,a+b,0,c+d],'inflate',44/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_prescribed*0+1;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        % Assemble the system matrix
        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        % Load
        efeb = feblock_defor_ss (struct ('mater',mater, 'gcells',subset(edge_gcells,edge_groups{5}),...
            'integration_rule',gauss_rule(1,2)));
        F = start (sysvec, get(u, 'neqns'));
        tol=0.00001*44;
        fi=force_intensity(struct('magn',[0;-magn]));
        F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
        % Solve
        u = scatter_sysvec(u, K\F);
        nl=fenode_select (fens,struct ('box',[48,48,52,52],'inflate',100*tol));
        theutip=gather(u,nl,'values');
        disp (['displacement =' num2str(theutip(2))])
        utip =[utip theutip(2)];
        
        nodal_stress = field_from_integration_points(feb, geom, u, [], 'Cauchy', 1:3);
        errors = error_elementwise (feb, geom, u, [], nodal_stress);
        elerrs=sqrt(sum(errors));
        targeterr=sqrt(sum(elerrs.^2)/Targetnel);
        
        x=zeros(length(fens),2);
        for j=1:length(fens)
            x(j,:)=get(fens(j),'xyz');
        end
        hcurs=zeros(length(fens),1)+Inf;
        hests=zeros(length(fens),1)+Inf;
        for j=1:length(gcells)
            conn=get(gcells(j),'conn');
            V=x(conn(2),:)-x(conn(1),:);
            W=x(conn(3),:)-x(conn(1),:);
            A=(V(1)*W(2)-V(2)*W(1))/2;
            hcur=sqrt(A*4/sqrt(3));
            errcur=elerrs(j);
            hest=hcur*(targeterr/errcur);
            for k=1:length(conn)
                hcurs(conn(k))=min([hcurs(conn(k)),hcur]);
                hests(conn(k))=min([hests(conn(k)),hest]);
            end
        end
        
        % Plot
        if graphics
            %             Plot errors
            if (Plot_errors)
                gv=graphic_viewer;
                gv=reset (gv,struct('limits', [-a,a+b,0,c+d+a]));
                cmap=cadcolors;
                nvals=sqrt(sum(errors));
                dcm=data_colormap(struct ('range',[min(nvals),max(nvals)], 'colormap',cmap));%[min(nvals),max(nvals)]
                for i=1:length(gcells)
                    color = map_data (dcm, nvals(i));
                    draw(gcells(i), gv, struct ('x',geom,'u', u, 'facecolor',color));
                end
                view (2)
                lighting  none;
                nvalsrange=[min(nvals),max(nvals)];
                cbh=colorbar;
                set(cbh,...
                    'Position',[0.8 0.15 0.05 0.7],...
                    'YLim',[0,1],...
                    'YTick',[0,1],...
                    'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
                set(get(cbh,'XLabel'),'String',['Error']);
            else
%                             Plots stresses
                sigj=2;
                fld = field_from_integration_points_spr(feb, geom, u, [], 'Cauchy', sigj);
                nvals=get(fld,'values');
%                 gv=graphic_viewer;
%                 gv=reset (gv,struct('limits', [-a,a+b,0,c+d+a]));
%                 cmap=cadcolors;
%                 nvalsrange=[-5*magn,magn];
% %                 nvalsrange=[min(nvals),max(nvals)];
%                 dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));%3*
%                 colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
%                 draw(feb, gv, struct ('x',geom,'u', scale*u, 'colorfield',colorfield, 'edgecolor','none'));
%                 lighting  none;
%                 title (['Stress']);
%                 colormap(cmap);
%                 cbh=colorbar;
%                 set(cbh,...
%                     'Position',[0.86 0.15 0.05 0.7],...
%                     'YLim',[0,1],...
%                     'YTick',[0,1],...
%                     'YTickLabel',{[num2str((min(nvalsrange)))],[num2str((max(nvalsrange)))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
%                 set(get(cbh,'XLabel'),'String',['\sigma_{' num2str(sigj) '}']);
%                 view (2)
zeta=linspace(0,1,100)';
p1=[0,1.001*c]; p2=p1+ [a+b,0];
xi=ones(size(zeta,1),1)*p1+zeta*(p2-p1);
tri=zeros(length(gcells),3);
for j=1:length(gcells)
            tri(j,:)=get(gcells(j),'conn');
end
fxi = simplex_grid_interpolation(x,nvals,tri,xi);
plot(zeta,fxi,'-x'); hold on
drawnow
            end
            
            [fens,gcells,groups,edge_gcells,edge_groups] = targe2_mesher_adapt(cat(2,fs,{['m-ctl-point constant ' num2str(min(hests))]}),hcurs,hests,x, 1.0);
            
        end
    end